#include "event.h"

#include <stdio.h>
#include <stdlib.h>

event * new_event()
{
  event *ret = (event *) malloc(sizeof(event));
  return ret;
}

void reset(event *event)
{
  event->infos = 0;
  event->key = 0;
  event->x = 0;
  event->y = 0;
}

void init_event(event *event, char is_pressed)
{
  reset(event);
  if (is_pressed) event->infos = 0x80;
}

void mouse_event(event *event, mouse_button button)
{
  init_event(event, 0);
  switch (button)
  {
    case LEFT: event->infos |= 0x01;
               break;
    case RIGHT: event->infos |= 0x02;
                break;
    case MIDDLE: event->infos |= 0x3;
                 break;
  }
}

void mouse_event_coord(event *event, mouse_button button, signed short x,
                       signed short y)
{
  mouse_event(event, button);
  event->x = x;
  event->y = y;
}

void kb_event(event *event, char key, char is_pressed) {}
